## tulip 6.0.1+dfsg

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.25...3.28)

#Setting project name and version (W.X.Y.Z if necessary)
PROJECT(Tulip
    VERSION 6.0.1
    DESCRIPTION "Large graphs analysis and drawing"
    HOMEPAGE_URL "https://tulip.labri.fr")
message(STATUS "Configuring ${CMAKE_PROJECT_NAME} ${Tulip_VERSION}")

# First display CMake version
MESSAGE(STATUS "Using CMake ${CMAKE_VERSION}")

# enable the use of ccache for Tulip developers to speed up the build process
IF(NOT MSVC)
  OPTION(TULIP_USE_CCACHE "Do you want to use ccache to speed up the build process during Tulip development ? [OFF|ON]" OFF)
  FIND_PROGRAM(CCACHE_PROGRAM ccache)
  IF(TULIP_USE_CCACHE AND CCACHE_PROGRAM)
      SET(CMAKE_CXX_COMPILER_LAUNCHER "${CCACHE_PROGRAM}")
      SET(CMAKE_C_COMPILER_LAUNCHER "${CCACHE_PROGRAM}")
  ENDIF(TULIP_USE_CCACHE AND CCACHE_PROGRAM)
ENDIF(NOT MSVC)

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

#convert CMAKE_INSTALL_PREFIX path into a cmake style path with unix /
#this is to avoid a path with a '\' as the last character which may be seen as
#an escape character (e.g. \")
FILE(TO_CMAKE_PATH "${CMAKE_INSTALL_PREFIX}" CMAKE_INSTALL_PREFIX)

# Force build type to release with debug info if none has been provided
IF(NOT MSVC AND "${CMAKE_BUILD_TYPE}" STREQUAL "")
  SET(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "" FORCE)
ENDIF(NOT MSVC AND "${CMAKE_BUILD_TYPE}" STREQUAL "")

## ========================================================
## Check processor architecture
## ========================================================
STRING(COMPARE EQUAL "${CMAKE_SIZEOF_VOID_P}" "8" IS_64BIT)
IF(IS_64BIT)
    add_compile_definitions("IS_64BIT")
  IF(CMAKE_SYSTEM_PROCESSOR MATCHES "arm64")
    add_compile_definitions("ARM64")
  ELSE()
    add_compile_definitions("X86_64")
  ENDIF()
ENDIF(IS_64BIT)

## ========================================================
## Consider *BSD as Linux
## ========================================================
IF(BSD)
    SET(LINUX TRUE)
ENDIF(BSD)

## ========================================================
## AppImage build
## ========================================================
IF (TULIP_BUILD_FOR_APPIMAGE)
  ADD_COMPILE_DEFINITIONS(APPIMAGE_BUILD)
ENDIF (TULIP_BUILD_FOR_APPIMAGE)

## ========================================================
## Install paths
## ========================================================

INCLUDE(GNUInstallDirs)

SET(TulipLibInstallDir ${CMAKE_INSTALL_LIBDIR})
SET(TulipPluginsInstallDir ${TulipLibInstallDir}/tulip)
SET(TulipGlyphPluginsInstallDir ${TulipPluginsInstallDir}/glyph)
SET(TulipViewPluginsInstallDir ${TulipPluginsInstallDir}/view)
SET(TulipInteractorPluginsInstallDir ${TulipPluginsInstallDir}/interactor)
SET(TulipPerspectivePluginsInstallDir ${TulipPluginsInstallDir}/perspective)
SET(TulipBinInstallDir ${CMAKE_INSTALL_BINDIR})
SET(TulipIncludeInstallDir ${CMAKE_INSTALL_INCLUDEDIR})
SET(TulipShareInstallDir ${CMAKE_INSTALL_DATADIR}/tulip)
SET(TulipBitmapInstallDir ${TulipShareInstallDir}/bitmaps)

## ========================================================
## Tulip CMake macros
## ========================================================
INCLUDE(cmake/TulipUseFile.cmake)

## ========================================================
## Tulip version variables
## ========================================================
SET(TulipVersionSeparator .)
IF(MSVC) #specific options for Visual Studio
  SET(TulipVersionSeparator _)
ENDIF()
SET(TulipMMVersion "${PROJECT_VERSION_MAJOR}${TulipVersionSeparator}${PROJECT_VERSION_MINOR}")
# Use two digits for the minor version when generating the Tulip integer version number
# as there was a 4.10 release that breaks preprocessor test like TULIP_INT_VERSION >= 4100 since the 5.0 release
# (see https://sourceforge.net/p/auber/bugs/869/)
STRING(LENGTH "${Tulip_VERSION_MINOR}" TulipMinorVersionNbDigits)
IF(TulipMinorVersionNbDigits LESS 2)
  SET(TulipMinorVersionTwoDigits "0${Tulip_VERSION_MINOR}")
ELSE(TulipMinorVersionNbDigits LESS 2)
  SET(TulipMinorVersionTwoDigits "${PROJECT_VERSION_MINOR}")
ENDIF(TulipMinorVersionNbDigits LESS 2)
SET(TulipIntMMVersion "${Tulip_VERSION_MAJOR}${TulipMinorVersionTwoDigits}")
SET(TulipIntVersion "${Tulip_VERSION_MAJOR}${TulipMinorVersionTwoDigits}${PROJECT_VERSION_PATCH}")

## ========================================================
## Tulip libraries names
## ========================================================
SET(LibTulipCoreName "tulip-core-${TulipMMVersion}")
SET(LibTulipOGLName "tulip-ogl-${TulipMMVersion}")
SET(LibTulipGUIName "tulip-gui-${TulipMMVersion}")
SET(LibTulipCorePythonBindingsName "tulip-core-python-bindings")
SET(LibTulipGUIPythonBindingsName "tulip-gui-python-bindings")
SET(TulipLibs ${LibTulipCoreName} ${LibTulipOGLName} ${LibTulipGUIName})

## ========================================================
## Compiler-specific options
## ========================================================

TULIP_SET_COMPILER_OPTIONS()

## ========================================================
## CORE ONLY
## this used to have a minimal build of Tulip without
## any of the opengl, qt or python components
## ========================================================
IF(NOT EXISTS ${PROJECT_SOURCE_DIR}/cmake/FindQtX.cmake)
  SET(TULIP_BUILD_CORE_ONLY ON)
  MESSAGE(STATUS "You can only configure a core build of Tulip.")
ELSE()
  SET(TULIP_BUILD_CORE_ONLY OFF CACHE BOOL "Do you want a minimal build of Tulip (no OpenGL rendering, no Qt gui, no documentation) ? [ON|OFF]")
ENDIF()

IF(TULIP_BUILD_CORE_ONLY AND LINUX)
# the macro ADD_CORE_FILES will be used
# to collect the files needed to build a minimal Tulip
# in the directory pointed by CMAKE_CURRENT_SOURCE_DIR
  MACRO(ADD_CORE_FILES files)
    SET(CURRENT_SOURCE_DIR ".")
    IF(${CMAKE_CURRENT_SOURCE_DIR} STRGREATER ${PROJECT_SOURCE_DIR})
      EXECUTE_PROCESS(COMMAND echo -n ${CMAKE_CURRENT_SOURCE_DIR}
                      COMMAND sed "s,${PROJECT_SOURCE_DIR}/,,"
                      OUTPUT_VARIABLE CURRENT_SOURCE_DIR)
    ENDIF()
    IF(${files} STREQUAL ".")
      SET(ENV{CORE_FILES} "$ENV{CORE_FILES} \$(find ${CURRENT_SOURCE_DIR} -path \"*/.svn\" -prune -o -type f -print)")
    ELSE()
      FOREACH(core_file ${ARGV})
        SET(ENV{CORE_FILES} "$ENV{CORE_FILES} ${CURRENT_SOURCE_DIR}/${core_file}")
      ENDFOREACH()
    ENDIF()
  ENDMACRO()
  ADD_CORE_FILES(CMakeLists.txt cmake/cmake_uninstall.cmake.in cmake/TulipUseFile.cmake cmake/FindTulip.cmake)
# the macro ADD_CORE_DIRECTORY_EXCEPT will be used
# to exclude the files not needed to build a minimal Tulip
# in the directory pointed by CMAKE_CURRENT_SOURCE_DIR
  MACRO(ADD_CORE_DIRECTORY_EXCEPT files)
    SET(CURRENT_SOURCE_DIR ".")
    IF(${CMAKE_CURRENT_SOURCE_DIR} STRGREATER ${PROJECT_SOURCE_DIR})
      EXECUTE_PROCESS(COMMAND echo -n ${CMAKE_CURRENT_SOURCE_DIR}
                      COMMAND sed "s,${PROJECT_SOURCE_DIR}/,,"
                      OUTPUT_VARIABLE CURRENT_SOURCE_DIR)
    ENDIF()
    SET(find_command "\$(find ${CURRENT_SOURCE_DIR} -path \"*/.svn\" -prune -o -type f")
    FOREACH(exclude_file ${ARGV})
      SET(find_command "${find_command} -a ! -name \"${exclude_file}\"")
    ENDFOREACH()
    SET(ENV{CORE_FILES} "$ENV{CORE_FILES} ${find_command} -print)")
  ENDMACRO()
ELSE()
  MACRO(ADD_CORE_FILES files)
  ENDMACRO()
  MACRO(ADD_CORE_DIRECTORY_EXCEPT files)
  ENDMACRO()
ENDIF()

  SET(TULIP_PYTHON_ROOT_FOLDER ${CMAKE_BINARY_DIR}/library/tulip-python/bindings/tulip-core/tulip_module)
  SET(TULIP_PYTHON_FOLDER ${TULIP_PYTHON_ROOT_FOLDER}/tulip)
  SET(TULIPGUI_PYTHON_ROOT_FOLDER ${CMAKE_BINARY_DIR}/library/tulip-python/bindings/tulip-gui/tulipgui_module)
  SET(TULIPGUI_PYTHON_FOLDER ${TULIPGUI_PYTHON_ROOT_FOLDER}/tulipgui)
  SET(TULIP_PYTHON_NATIVE_FOLDER ${TULIP_PYTHON_FOLDER}/native)
  SET(TULIPGUI_PYTHON_NATIVE_FOLDER ${TULIPGUI_PYTHON_FOLDER}/native)
  SET(TULIP_ACTIVATE_PYTHON_WHEEL_TARGET OFF CACHE BOOL "Add a wheel make target for generating Python tulip-core module wheel ? [ON|OFF]")
  IF(TULIP_ACTIVATE_PYTHON_WHEEL_TARGET)
    SET(TULIP_BUILD_CORE_ONLY ON)
    # build binaries with install rpath when generating Tulip Python wheels
    # as we don't install the project in that case
    SET(CMAKE_BUILD_WITH_INSTALL_RPATH ON)
    IF(LINUX)
        #check we are running under manylinux
        execute_process(
            COMMAND manylinux-interpreters list
            RESULT_VARIABLE EXIT_CODE
            OUTPUT_QUIET
    )
    if (NOT ${EXIT_CODE} EQUAL 0)
        MESSAGE(FATAL_ERROR "Python binary wheels for Linux platform must be compiled using manylinux from the Python Packaging Authority.\nSee https://github.com/pypa/manylinux for more details.")
    endif()
    ENDIF(LINUX)
  ENDIF(TULIP_ACTIVATE_PYTHON_WHEEL_TARGET)

  ## ========================================================
  ## Required packages
  ## ========================================================

  FIND_PACKAGE(ZLIB REQUIRED)

# Python (need to put this here to initialize Qhull properly when compiling Python wheels
#qhull libs from manylinux-2.28 (Almalinux 8) does not work. Paclage cmeel-qhull should be used instead
IF(TULIP_ACTIVATE_PYTHON_WHEEL_TARGET)
# When building tulip wheels we make a loop of cmake builds,
# with only a change of Python_EXECUTABLE CMake variable;
# so we need to unset the previous values of the CMake Python cache variables
# to force their recomputation
  UNSET(Python_FOUND CACHE)
  #force to rediscover Qhull for each build (use the cmeel package from the same Python version)
  UNSET(PKG_CONFIG_ARGN CACHE)
  UNSET(Qhull_FOUND CACHE)
  UNSET(Qhull_LIBDIR CACHE)
  SET(PYTHON_COMPONENTS Interpreter Development.Module)
ELSE(TULIP_ACTIVATE_PYTHON_WHEEL_TARGET)
  SET(PYTHON_COMPONENTS Interpreter Development)
ENDIF(TULIP_ACTIVATE_PYTHON_WHEEL_TARGET)
FIND_PACKAGE(Python 3.9...<3.14 REQUIRED COMPONENTS ${PYTHON_COMPONENTS})

FIND_PACKAGE(PkgConfig REQUIRED)
IF(LINUX AND TULIP_ACTIVATE_PYTHON_WHEEL_TARGET)
#QHULL bundled with manylinux 2.28 is not working
#use the cmeel-qhull package from Pypi (need to be installed before running cmake)
SET(PKG_CONFIG_ARGN "--with-path=${Python_SITELIB}/cmeel.prefix/lib/pkgconfig")
ENDIF(LINUX AND TULIP_ACTIVATE_PYTHON_WHEEL_TARGET)
PKG_search_module(Qhull REQUIRED qhull_r>8 IMPORTED_TARGET)
PKG_search_module(Yajl REQUIRED yajl>2 IMPORTED_TARGET)

#Python
INCLUDE(cmake/TulipPython.cmake)

IF(NOT TULIP_BUILD_CORE_ONLY AND NOT TRAVIS_BUILD_THIRDPARTY_ONLY)
  # OpenGL
  FIND_PACKAGE(OpenGL REQUIRED COMPONENTS OpenGL)

  # Glew
  FIND_PACKAGE(GLEW REQUIRED)

IF(TULIP_BUILD_GL_TEX_LOADER)
  # Jpeg
  FIND_PACKAGE(JPEG REQUIRED)

  # Png
  FIND_PACKAGE(PNG REQUIRED)
ENDIF(TULIP_BUILD_GL_TEX_LOADER)

  # Freetype
  FIND_PACKAGE(Freetype REQUIRED)

  # Qt
  FIND_PACKAGE(QtX)
  # Display Qt detected version
  MESSAGE(STATUS "Using Qt version ${QT_FULL_VERSION}")

  FIND_PACKAGE(libzip REQUIRED)

ENDIF(NOT TULIP_BUILD_CORE_ONLY AND NOT TRAVIS_BUILD_THIRDPARTY_ONLY)

## ========================================================
## Include and library paths
## ========================================================
SET(GZStreamInclude ${PROJECT_SOURCE_DIR}/thirdparty/gzstream/)
SET(GZStreamLibrary gzstream)
IF(NOT TULIP_BUILD_CORE_ONLY AND NOT TRAVIS_BUILD_THIRDPARTY_ONLY)
  SET(FTGLInclude ${PROJECT_SOURCE_DIR}/thirdparty/ftgl/)
  SET(FTGLLibrary ftgl)
  ADD_COMPILE_DEFINITIONS(FTGL_LIBRARY_STATIC)
  SET(Tess2Include ${PROJECT_SOURCE_DIR}/thirdparty/libtess2/Include)
  SET(Tess2Library tess2)
  ADD_COMPILE_DEFINITIONS(TESS2_LIBRARY_STATIC)
ENDIF(NOT TULIP_BUILD_CORE_ONLY AND NOT TRAVIS_BUILD_THIRDPARTY_ONLY)

SET(OGDFInclude ${PROJECT_SOURCE_DIR}/thirdparty/OGDF/include)
SET(OGDFBuildInclude ${PROJECT_BINARY_DIR}/thirdparty/OGDF/include)
SET(OGDFLibrary OGDF)

#utf8-cpp
find_package(utf8cpp QUIET)
IF(utf8cpp_FOUND)
    IF(TARGET utf8cpp) #Gentoo linux is looking for utf8cpp only

=== doc/CMakeLists.txt ===
SET(TULIP_BUILD_DOC ON CACHE BOOL "Do you want to build the documentation ? [ON|OFF]")

#Only
IF(TULIP_BUILD_DOC AND NOT TULIP_ACTIVATE_PYTHON_WHEEL_TARGET)
  STRING(TIMESTAMP CurrentYear "%Y")

  FIND_PACKAGE(Sphinx)
  IF(SPHINX_FOUND)
    ADD_SUBDIRECTORY(python)
    ADD_SUBDIRECTORY(user)
    ADD_SUBDIRECTORY(developer)
  ELSE(SPHINX_FOUND)
    MESSAGE(AUTHOR_WARNING "Sphinx not found: unable to generate the documentation.")
  ENDIF(SPHINX_FOUND)

  IF(LINUX AND NOT TULIP_BUILD_FOR_APPIMAGE)
    FIND_PACKAGE(Doxygen)
    IF(DOXYGEN_FOUND)
      ADD_SUBDIRECTORY(doxygen)
    ELSE(DOXYGEN_FOUND)
      MESSAGE(AUTHOR_WARNING "doxygen not found: unable to generate the Tulip API documentation.")
    ENDIF(DOXYGEN_FOUND)
  ENDIF(LINUX AND NOT TULIP_BUILD_FOR_APPIMAGE)
ENDIF(TULIP_BUILD_DOC AND NOT TULIP_ACTIVATE_PYTHON_WHEEL_TARGET)

=== externalplugins/CMakeLists.txt ===
SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_MODULE_PATH})

#Automatic subdirectory search for CMakeLists.txt
FILE(GLOB CM_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/*/CMakeLists.txt)

SET(EXTERNALPLUGINS TRUE)

INCLUDE_DIRECTORIES(${TulipCoreBuildInclude} ${TulipCoreInclude} ${TulipOGLInclude} ${TulipGUIInclude})

FOREACH(CM_FILE ${CM_FILES})
STRING(REGEX REPLACE "/CMakeLists.txt" "" CM_SUBDIR ${CM_FILE})
ADD_SUBDIRECTORY(${CM_SUBDIR})
ENDFOREACH(CM_FILE)

=== library/CMakeLists.txt ===
ADD_CORE_FILES(CMakeLists.txt)

ADD_SUBDIRECTORY(tulip-core)
ADD_SUBDIRECTORY(tulip-python)
IF(NOT TULIP_BUILD_CORE_ONLY)
  ADD_SUBDIRECTORY(tulip-ogl)
  ADD_SUBDIRECTORY(tulip-gui)
ENDIF(NOT TULIP_BUILD_CORE_ONLY)

=== plugins/CMakeLists.txt ===
ADD_CORE_FILES(CMakeLists.txt)

ADD_SUBDIRECTORY(clustering)
ADD_SUBDIRECTORY(export)
ADD_SUBDIRECTORY(general)
ADD_SUBDIRECTORY(import)
ADD_SUBDIRECTORY(layout)
ADD_SUBDIRECTORY(metric)
ADD_SUBDIRECTORY(selection)
ADD_SUBDIRECTORY(sizes)
ADD_SUBDIRECTORY(test)
ADD_SUBDIRECTORY(colors)
ADD_SUBDIRECTORY(string)
IF(NOT TULIP_BUILD_CORE_ONLY)
ADD_SUBDIRECTORY(glyph)
ADD_SUBDIRECTORY(interactor)
ADD_SUBDIRECTORY(perspective)
ADD_SUBDIRECTORY(view)
ENDIF(NOT TULIP_BUILD_CORE_ONLY)

=== software/CMakeLists.txt ===
INSTALL(DIRECTORY bitmaps/
        DESTINATION ${TulipBitmapInstallDir}
        COMPONENT tulip_app)
ADD_SUBDIRECTORY(crash_handling)
ADD_SUBDIRECTORY(tulip)

=== thirdparty/CMakeLists.txt ===
TULIP_DISABLE_COMPILER_WARNINGS()

ADD_CORE_FILES(CMakeLists.txt
               utf8-cpp/source/utf8.h
               utf8-cpp/source/utf8/checked.h
               utf8-cpp/source/utf8/core.h
               utf8-cpp/source/utf8/unchecked.h
               utf8-cpp/source/utf8/cpp11.h
               utf8-cpp/source/utf8/cpp17.h
)

ADD_SUBDIRECTORY(gzstream)
ADD_SUBDIRECTORY(OGDF)
ADD_SUBDIRECTORY(antlr)
ADD_SUBDIRECTORY(xdkbibtex)

IF(NOT TULIP_BUILD_CORE_ONLY AND NOT TRAVIS_BUILD_THIRDPARTY_ONLY)
  ADD_SUBDIRECTORY(ftgl)
  ADD_SUBDIRECTORY(libtess2)
ENDIF(NOT TULIP_BUILD_CORE_ONLY AND NOT TRAVIS_BUILD_THIRDPARTY_ONLY)

=== doc/developer/CMakeLists.txt ===
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/conf.py.in ${CMAKE_CURRENT_BINARY_DIR}/conf.py)

# Turn CMAKE_LIBRARY_PATH list into a string in order to pass all its contents to the CMake command generating the doc,
# only the first list entry is transferred otherwise.
STRING(REPLACE ";" "," CMAKE_LIBRARY_PATH_STR "${CMAKE_LIBRARY_PATH}")

# Ensure that libraries paths are in MSYS format when using MSYS Makefiles,
# otherwise the documentation fails to build
IF("${CMAKE_GENERATOR}" MATCHES ".*MSYS.*")
  file(TO_CMAKE_PATH "${CMAKE_LIBRARY_PATH_STR}" CMAKE_LIBRARY_PATH_STR)
ENDIF("${CMAKE_GENERATOR}" MATCHES ".*MSYS.*")

ADD_CUSTOM_TARGET(devDoc ALL ${CMAKE_COMMAND} -DSPHINX_EXECUTABLE=${SPHINX_EXECUTABLE}
                                              -c ${CMAKE_CURRENT_BINARY_DIR}
                                              -DSRC_DIR=${CMAKE_CURRENT_SOURCE_DIR}
                                              -DBIN_DIR=${CMAKE_CURRENT_BINARY_DIR}
                                              -DAPPLE=${APPLE} -DWIN32=${WIN32}
                                              -DCMAKE_LIBRARY_PATH=${CMAKE_LIBRARY_PATH_STR}
                                              -P ${CMAKE_CURRENT_SOURCE_DIR}/genSphinxDoc.cmake
                                              VERBATIM)

SET_DIRECTORY_PROPERTIES(PROPERTIES ADDITIONAL_CLEAN_FILES "doc;doctrees")

INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html 
        DESTINATION ${CMAKE_INSTALL_DOCDIR}/tulip-dev
        COMPONENT tulip_dev_doc)

=== doc/doxygen/CMakeLists.txt ===
# this doc is only build & installed on linux or MacOSX
# when doxygen is available
# check for dot to enable the generation of class diagrams
IF(DOXYGEN_DOT_FOUND)
  SET(DOXY_HAVE_DOT "YES")
ELSE(DOXYGEN_DOT_FOUND)
  SET(DOXY_HAVE_DOT "NO")
  MESSAGE(AUTHOR_WARNING "dot tool not found: doxygen diagrams and graphs will not be generated")
ENDIF(DOXYGEN_DOT_FOUND)

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/tulip.doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/tulip.doxyfile)

# custom css for navtree and tabs does not work anymore since the 1.8.13 release of doxygen, use default theme instead
IF(DOXYGEN_VERSION VERSION_GREATER 1.8.13 OR DOXYGEN_VERSION VERSION_EQUAL 1.8.13)
  ADD_CUSTOM_TARGET(doxydoc ALL
    ${CMAKE_COMMAND} -E remove_directory ${CMAKE_CURRENT_BINARY_DIR}/html
    COMMAND doxygen ${CMAKE_CURRENT_BINARY_DIR}/tulip.doxyfile
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${PROJECT_SOURCE_DIR}/doc/html ${CMAKE_CURRENT_BINARY_DIR}/html
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/style/doxygen.css ${CMAKE_CURRENT_BINARY_DIR}/html
    COMMAND ${CMAKE_COMMAND} -E remove_directory ${PROJECT_SOURCE_DIR}/doc/html
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR} VERBATIM)
ELSE()
  ADD_CUSTOM_TARGET(doxydoc ALL
    ${CMAKE_COMMAND} -E remove_directory ${CMAKE_CURRENT_BINARY_DIR}/html
    COMMAND doxygen ${CMAKE_CURRENT_BINARY_DIR}/tulip.doxyfile
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${PROJECT_SOURCE_DIR}/doc/html ${CMAKE_CURRENT_BINARY_DIR}/html
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/style/doxygen.css ${CMAKE_CURRENT_BINARY_DIR}/html
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/style/navtree.css ${CMAKE_CURRENT_BINARY_DIR}/html
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/style/tabs.css ${CMAKE_CURRENT_BINARY_DIR}/html
    COMMAND ${CMAKE_COMMAND} -E remove_directory ${PROJECT_SOURCE_DIR}/doc/html
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR} VERBATIM)
ENDIF()

INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html 
        DESTINATION ${CMAKE_INSTALL_DOCDIR}/doxygen
        COMPONENT doxygen_doc)

=== doc/python/CMakeLists.txt ===
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/conf.py.in ${CMAKE_CURRENT_BINARY_DIR}/conf.py)

# On windows, it is required that the paths to the dll dependencies (e.g. zlib, libpng, ...) are contained
# in the CMAKE_LIBRARY_PATH variable (especially with Visual Studio).
# Some warnings will be output when configuring the whole project if it is not the case.
# Otherwise, the Python API documentation will not be generated as the import of the tulip modules will fail.

# Turn CMAKE_LIBRARY_PATH list into a string in order to pass all its contents to the CMake command generating the doc,
# only the first list entry is transferred otherwise.
STRING(REPLACE ";" "," CMAKE_LIBRARY_PATH_STR "${CMAKE_LIBRARY_PATH}")

# Ensure that libraries paths are in MSYS format when using MSYS Makefiles,
# otherwise the documentation fails to build
IF("${CMAKE_GENERATOR}" MATCHES ".*MSYS.*")
  file(TO_CMAKE_PATH "${CMAKE_LIBRARY_PATH_STR}" CMAKE_LIBRARY_PATH_STR)
ENDIF("${CMAKE_GENERATOR}" MATCHES ".*MSYS.*")

# copy .py files in CMAKE_CURRENT_BINARY_DIR
# in order to avoid polluting the source tree with python .pyc files
FILE(GLOB PYFILES *.py)
FILE(COPY ${PYFILES} DESTINATION .)

ADD_CUSTOM_TARGET(pythonBindingsDoc ALL ${CMAKE_COMMAND} -DSPHINX_EXECUTABLE=${SPHINX_EXECUTABLE}
                                                         -DPython_EXECUTABLE=${Python_EXECUTABLE}
                                                         -DSRC_DIR=${CMAKE_CURRENT_SOURCE_DIR}
                                                         -DBIN_DIR=${CMAKE_CURRENT_BINARY_DIR}
                                                         -DTULIP_SOURCE_DIR=${CMAKE_SOURCE_DIR}
                                                         -DTULIP_BUILD_DIR=${CMAKE_BINARY_DIR}
                                                         -DQT_BIN_DIR=${QT_BINARY_DIR}
                                                         -DAPPLE=${APPLE} -DWIN32=${WIN32}
                                                         -DCMAKE_LIBRARY_PATH=${CMAKE_LIBRARY_PATH_STR}
                                                         -P ${CMAKE_CURRENT_SOURCE_DIR}/genSphinxDoc.cmake
                                    DEPENDS ${LibTulipCorePythonBindingsName}
                                            ${LibTulipGUIPythonBindingsName}
                                            ${TULIP_PLUGIN_TARGETS}
                                            copyTulipPythonPlugins
					    copyTulipPluginsPyInBuild
                                    VERBATIM)

SET_DIRECTORY_PROPERTIES(PROPERTIES ADDITIONAL_CLEAN_FILES "doc;doctrees")

INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html 
        DESTINATION ${CMAKE_INSTALL_DOCDIR}/tulip-python
        COMPONENT tulip_python_doc)

=== doc/user/CMakeLists.txt ===
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/conf.py.in ${CMAKE_CURRENT_BINARY_DIR}/conf.py)

# Turn CMAKE_LIBRARY_PATH list into a string in order to pass all its contents to the CMake command generating the doc,
# only the first list entry is transferred otherwise.
STRING(REPLACE ";" "," CMAKE_LIBRARY_PATH_STR "${CMAKE_LIBRARY_PATH}")

# Ensure that libraries paths are in MSYS format when using MSYS Makefiles,
# otherwise the documentation fails to build
IF("${CMAKE_GENERATOR}" MATCHES ".*MSYS.*")
  file(TO_CMAKE_PATH "${CMAKE_LIBRARY_PATH_STR}" CMAKE_LIBRARY_PATH_STR)
ENDIF("${CMAKE_GENERATOR}" MATCHES ".*MSYS.*")

ADD_CUSTOM_TARGET(userDoc ALL ${CMAKE_COMMAND} -DSPHINX_EXECUTABLE=${SPHINX_EXECUTABLE}
                                               -DBIN_DIR=${CMAKE_CURRENT_BINARY_DIR}
                                               -DSRC_DIR=${CMAKE_CURRENT_SOURCE_DIR}
                                               -DAPPLE=${APPLE} -DWIN32=${WIN32}
                                               -DCMAKE_LIBRARY_PATH=${CMAKE_LIBRARY_PATH_STR}
                                               -P ${CMAKE_CURRENT_SOURCE_DIR}/genSphinxDoc.cmake
                                               VERBATIM)

SET_DIRECTORY_PROPERTIES(PROPERTIES ADDITIONAL_CLEAN_FILES "doc;doctrees")

INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html 
        DESTINATION ${CMAKE_INSTALL_DOCDIR}/tulip-user
        COMPONENT tulip_user_doc)

=== library/tulip-gui/CMakeLists.txt ===
IF(WIN32)
    add_compile_definitions("DLL_TULIP_QT")
ENDIF(WIN32)

INSTALL(DIRECTORY samplePictures colorscales
        DESTINATION ${TulipBitmapInstallDir})

ADD_SUBDIRECTORY(include)
ADD_SUBDIRECTORY(src)

=== debian/changelog ===
tulip (6.0.1+dfsg-2ubuntu1) resolute; urgency=medium

  * Bump allowed Python versions

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 05 Feb 2026 11:26:09 +0000

tulip (6.0.1+dfsg-2build1) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 23 Jan 2026 20:03:43 +0000

=== debian/control ===
Source: tulip
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: James Turton <james@somecomputer.xyz>
Section: graphics
Priority: optional
Build-Depends: debhelper-compat (= 13),
               ca-certificates,
               cmake,
               ninja-build,
               doxygen,
               graphviz,
               libqhull-dev,
               libyajl-dev,
               libcppunit-dev,
               qtbase5-dev,
               libqt5opengl5-dev,
               qtwebengine5-dev,
               libzip-dev,
               libftgl-dev,
               libglew-dev,
               libpng-dev,
               libjpeg-dev,
               libfreetype-dev,
               libutfcpp-dev,
               python3,
               python3-sphinx,
               libpython3-dev,
               sip-tools,
               pkgconf,
               libgzstream-dev,
               libantlr-dev,
               docbook-to-man
Build-Conflicts: binutils-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/science-team/tulip
Vcs-Git: https://salsa.debian.org/science-team/tulip.git
Homepage: http://tulip.labri.fr/
Rules-Requires-Root: no

Package: tulip
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         python3,
         fonts-dejavu-core,
         fonts-font-awesome,
         fonts-materialdesignicons-webfont,
         python3-sipbuild
Suggests: qtwayland5
Description: System dedicated to the visualization of huge data sets as graphs
 Tulip is an information visualization framework dedicated to the analysis and
 visualization of relational data.  It aims to provide the developer with a
 complete library, supporting the design of interactive information
 visualization applications for relational data that can be tailored to the
 problems he or she is addressing.
 .
 It includes the following features:
 .
  * 3D visualizations
  * 3D modifications
  * Plug-in support for easy evolution
  * Building of clusters and navigation into them
  * Automatic drawing of graphs
  * Automatic clustering of graphs
  * Automatic selection of elements
  * Automatic metric coloration of graphs

Package: libtulip-dev
Architecture: any
Section: libdevel
Depends: tulip (= ${binary:Version}),
         libc6-dev,
         ${misc:Depends}
Suggests: cmake
Enhances: qtcreator
Conflicts: libtulip-dev
Replaces: libtulip-ogl-dev,
          libtulip-qt4-dev
Description: Tulip graph library - core development files
 Headers and static libraries for tulip, a system dedicated to the
 visualization of huge graphs.  Also includes QtCreator templates.

Package: libtulip-core-6.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Tulip graph library - core runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This is the core of the system, excluding the OpenGL rendering capabilities.

Package: libtulip-ogl-6.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Tulip graph library - OpenGL runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This library contains the OpenGL rendering capabilities of the engine.

Package: libtulip-gui-6.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Tulip graph library - Qt/OpenGL GUI runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This library contains the Qt/OpenGL GUI support.

Package: libtulip-python-6.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Conflicts: libtulip-python
Provides: libtulip-python
Description: Tulip graph library - Python support
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This library contains the Python scripting support.

Package: libogdf-tulip-6.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Open Graph Drawing Framework shared library, built for Tulip
 This is the Open Graph Drawing Framework library, built as a shared
 lib as required by Tulip.
